package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;


public class ConsumoPorServicoPage extends PageBase {

    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaConsumo = By.xpath("//span[text() = 'Consumo']");
    By acessaConsumoPorServico = By.xpath("//span[text() = 'Consumo por Serviço']");
    By limpaFiltro = By.xpath("//*[@zh-icon='no-border close-x']");
    By filtroUnidade = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon = 'no-border search']");
    By inputUnidade = By.xpath("//*[@id='popup']//input[@type = 'text']");
    By clicaUnidade = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By clicaServico = By.xpath("//div[@id = 'NMSERVICO']/span");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaCampoBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By tipoConsumo = By.xpath("//div[@data-zh-id='12493230851921139535695']//span[@class = 'current']");
    By consumoPerCapita = By.xpath("//div[@data-zh-id='12493230851921139535695']//ul[@class = 'list zh-new-select-list']//li[text() = 'Per Capita']");
    By opcaoconsumoFixo = By.xpath("//div[@data-zh-id='12493230851921139535695']//ul[@class = 'list zh-new-select-list']//li[text() = 'Fixo']");
    By diaConsumo = By.xpath("//div[@data-zh-id='12493230851216446346697']//span[@class = 'current']");
    By segundaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Segunda-Feira']");
    By tercaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Terça-Feira']");
    By quartaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Quarta-Feira']");
    By quintaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Quinta-Feira']");
    By sextaFeira = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Sexta-Feira']");
    By Sabado = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Sábado']");
    By Domingo = By.xpath("//div[@data-zh-id='12493230851216446346697']//li[text() = 'Domingo']");
    By limpaDtInicioValidade = By.xpath("//div[@class = 'zh-select-date zh-field-DTCONSSERV']//span[@zh-icon= 'no-border close-x']");
    By dtInicioValidade = By.xpath("//input[@id = 'DTCONSSERV']");
    By btnCalendario = By.xpath("//span[@zh-icon='calendar']");
    By btnAdicionar = By.xpath("//a[@data-zh-title-tooltip = 'F2']");
    By msgEsperada = By.xpath("//span[text() = 'CREOSOTO']");
    By msgEsperada_2 = By.xpath("//span[text() = 'OLEO DE COPAIBA']");

    //Filtro de Produto
    By buscaProduto = By.xpath("//span[@zh-icon='no-border search']");
    By selecionaProduto = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By qtdProduto = By.xpath("//input[@id = 'QTCONSSERV']");
    By pontoDeEntrega = By.xpath("//div[@data-zh-id='12493230854082222163725']//span[@class='current']");
    By btnSim = By.xpath("//li[text() = 'Sim']");
    By opcaoCozinhaCentral = By.xpath("//div[@data-zh-id='12493230853450296414726']//span[@class = 'current']");
    By opcaoentregaDireta = By.xpath("//li[text() = 'Entrega Direta']");
    By opcaoDistribuicao = By.xpath("//li[text() = 'Distribuição']");
    By usoDaCentral = By.xpath("//input[@id = 'QTUTILCENTRAL']");
    By diaDeConsumo = By.xpath("//div[@data-zh-id='12493230852618700311728']//span[@class = 'current']");
    By opcaoSegundaFeira = By.xpath("//li[text() = 'Segunda-feira']");
    By opcaoTercaFeira = By.xpath("//li[text() = 'Terça-feira']");
    By opcaoQuartaFeira = By.xpath("//li[text() = 'Quarta-feira']");
    By opcaoQuintaFeira = By.xpath("//li[text() = 'Quinta-feira']");
    By opcaoSextaFeira = By.xpath("//li[text() = 'Sexta-feira']");
    By opcaoSabado = By.xpath("//li[text() = 'Sábado']");
    By opcaoDomingo = By.xpath("//li[text() = 'Domingo']");
    By opcaoFeriado = By.xpath("//li[text() = 'Feriado']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By carregaGrid = By.xpath("//div[@class = 'body-content']");

    //Aba Exceções
    By btnExcecoes = By.xpath("//a[text() = 'Exceções']");
    By dtExcecao = By.xpath("//div[@data-date = '18/10/2022']");
    By btnPontoEntrega = By.xpath("//div[@data-zh-id='1249323085417169779758']//span[@class='current']");

    //Edição produto Exceção
    By selecionarProduto = By.xpath("//*[@id='grid-12493230852520223399749']/div[2]/div/div/div[1]");
    By btnEditar = By.xpath("//a[@data-zh-title-tooltip = 'F3']");
    By btnExcluir = By.xpath("//a[@data-zh-title-tooltip = 'Ctrl+d']");
    By cozinhaCentral = By.xpath("//div[@data-zh-id='12493230852410174743311']//span[@class = 'current']");
    By confirmaMensagem = By.xpath("//section[@class = 'zh-container-alert']//span[text() = 'Sim']");
    By msgExclusao = By.xpath("//p[text() = 'Não há registros']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");

    // Aba Dia sem Consumo
    By btnDiaSemConsumo = By.xpath("//a[text() = 'Dias Sem Consumo']");
    By primeiroDiaSemConsumo = By.xpath("//div[@data-date = '05/10/2022']");
    By segundoDiaSemConsumo = By.xpath("//div[@data-date = '10/10/2022']");
    By opcaoConsumoDia = By.xpath("//section[@class = 'popup-container']//div[@data-zh-id='12493230852729638746782']//span[@class = 'current']");
    By diaConsumoFixo = By.xpath("//section[@data-ng-if='popupOpen']//*[@data-zh-id='12493230852089173430780']//div[@data-zh-id='12493230852729638746782']//ul[@class = 'list zh-new-select-list']//li[text() = 'Fixo']");
    By diaConsumoPerCapita = By.xpath("//section[@data-ng-if='popupOpen']//*[@data-zh-id='12493230852089173430780']//div[@data-zh-id='12493230852729638746782']//ul[@class = 'list zh-new-select-list']//li[text() = 'Per Capita']");

    //Alterar/Excluir Consumo

    By clicaProduto = By.xpath("//*[@id='grid-1249323085964931782718']//div[@class = 'tr cell1']");
    By clicarProduto = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[1]");
    By abaConsumo = By.xpath("//a[text() = 'Consumo']");
    By btnOk = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'OK']");
    By editaProduto_1 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[1]/div[3]/div");
    By novaQtdProduto_1 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[1]/div[3]/div/input");
    By editaProduto_2 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[3]/div");
    By NovaQtdProduto_2 = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[3]/div/input");
    By qtdCentral = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[7]/div");
    By informaQtdCentral = By.xpath("//*[@id='grid-1249323085964931782718']/div[2]/div/div[2]/div[7]/div/input");
    By excluirProduto = By.xpath("//li[@data-zh-id='12493230853982378352739']//a[@data-zh-title-tooltip]");

    By primeiroProduto = By.xpath("//div[@id='grid-1249323085964931782718']//div[@class = 'tr cell1']");
    By editarProduto_2 = By.xpath("//div[@id='grid-1249323085964931782718']//div[@class = 'tr cell2']");
    By salvarAlteracoes = By.xpath("//*[text() = 'Salvar alterações']");

    //Consumo Per Capita
    By cozinhaCentralDistribuicao = By.xpath("//div[@data-zh-id='12493230852410174743311']//span[@class = 'current']");

    //Ações Importação Consumo
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnImportarConsumo = By.xpath("//span[text() = 'Importação de Consumo']");
    By btnExportarConsumo = By.xpath("//span[text() = 'Exportação de Consumo']");
    By btnSubstituirProduto = By.xpath("//span[text() = 'Substituição de Produto']");
    By tipoDeConsumo = By.xpath("//div[@data-zh-id='2201729922951263217848']//span[@class = 'current']");
    By opcaoconsumoPerCapita = By.xpath("//div[@data-zh-id='2201729922951263217848']//ul[@class = 'list zh-new-select-list']//li[text() = 'Per Capita']");
    By consumoFixo = By.xpath("//div[@data-zh-id='2201729922951263217848']//ul[@class = 'list zh-new-select-list']//li[text() = 'Fixo']");
    By diaImportacao = By.xpath("//div[@data-zh-id='2201729922612767889851']//span[@class = 'current']");
    By importaSegundaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Segunda-Feira']");
    By importaTercaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Terça-Feira']");
    By importaQuartaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Quarta-Feira']");
    By importaQuintaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Quinta-Feira']");
    By importaSextaFeira = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Sexta-Feira']");
    By importaSabado = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Sábado']");
    By importaDomingo = By.xpath("//div[@data-zh-id='2201729922612767889851']//li[text() = 'Domingo']");
    By dadosExistentes = By.xpath("//div[@data-zh-id='220172992808612627852']//span[@class = 'current']");
    By opcaoSobrepor = By.xpath("//div[@data-zh-id='220172992808612627852']//li[text() = 'Sobrepor']");
    By btnAplicarFiltro = By.xpath("//div[@id = 'footer']//span[text() = 'Aplicar filtro']");
    By selecionaServico = By.xpath("//div[@class = 'tr cell2']");
    By marcarTodos = By.xpath("//div[@class = 'th grid-checkbox-column fixed']");
    By btnImportar = By.xpath("//span[text() = 'Importar']");

    //Ações Exportar Consumo
    By btnExportar = By.xpath("//li[@data-zh-id='6580556122671439818830']//span[text() = 'Exportar']");
    By exportarDestino = By.xpath("//div[@id = 'NOMEIDTIPOCONS']");
    By exportaSegunda = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]");
    By exportaTerca = By.xpath("//*[@id='grid-9999']/div[2]/div/div[3]/div[1]");
    By exportaQuarta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[4]/div[1]");
    By exportaQuinta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[5]/div[1]");
    By exportaSexta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[6]/div[1]");
    By exportaSabado = By.xpath("//*[@id='grid-9999']/div[2]/div/div[7]/div[1]");
    By exportaDomingo = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]");
    By okExportaConsumo = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By confirmaExportacao = By.xpath("//li[@data-zh-id='6580556124178481369822']//span[text() = 'Confirmar']");

    //Substituir Produto
    By produtoOrigem = By.xpath("//div[@id = 'NMPRODORI']//span[@zh-icon='no-border search']");
    By opcaoTodosUnidade = By.xpath("//label[@for = 'zh-checkbox-T_NMFILIAL']//span[@zh-icon='checked no-border']");
    By campoUnidade = By.xpath("//div[@id = 'NMFILIAL']");
    By confirmaBusca = By.xpath("//*[@class='tr cell1']");
    By btnOK = By.xpath("//div[@class = 'zh-footer-right']//span[text() = 'Ok']");
    By opcaoTodosServico = By.xpath("//label[@for = 'zh-checkbox-T_NMSERVICO']//span[@zh-icon='checked no-border']");
    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");
    By campoTipoConsumo = By.xpath("//div[@data-zh-id='13049218833760544966901']//span[@class = 'current']");
    By exportaConsumoFixo = By.xpath("//li[text() = 'Fixo']");
    By exportaConsumoPerCapita = By.xpath("//li[text() = 'Per Capita']");
    By exportaConsumoAmbos = By.xpath("//li[text() = 'Ambos']");
    By diaConsumoTrocaProduto = By.xpath("//div[@name= 'IDTIPOCONS']");
    By trocaProdutoSegunda = By.xpath("//*[@id='grid-9999']/div[2]/div/div[2]/div[1]");
    By trocaProdutoTerca = By.xpath("//*[@id='grid-9999']/div[2]/div/div[3]/div[1]");
    By trocaProdutoQuarta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[4]/div[1]");
    By trocaProdutoQuinta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[5]/div[1]");
    By trocaProdutoSexta = By.xpath("//*[@id='grid-9999']/div[2]/div/div[6]/div[1]");
    By trocaProdutoSsabado = By.xpath("//*[@id='grid-9999']/div[2]/div/div[7]/div[1]");
    By trocaProdutoDomingo = By.xpath("//*[@id='grid-9999']/div[2]/div/div[1]/div[1]");
    By produtoDestino = By.xpath("//div[@id= 'NMPRODDEST']//span[@zh-icon='no-border search']");
    By checkBoxSubstituirProduto = By.xpath("//*[@id='grid-13049218831525648582924']/div[1]/div/div/div[1]");
    By btnSubstituir = By.xpath("//li[@data-zh-id='1304921883889935404931']");

    //Importar Exceção
    By importaExcecao = By.xpath("//span[text() = 'Importação de Exceção']");
    By exportaExcecao = By.xpath("//span[text() = 'Exportação de Exceção']");
    By substituiExcecao = By.xpath("//span[text() = 'Substituição de Produto']");
    By diaConsumoExcecao = By.xpath("//div[@data-zh-id='2201729922612767889851']//span[@class = 'current']");
    By excecaoSegundaFeira = By.xpath("//li[text() = 'Segunda-Feira']");
    By excecaoTercaFeira = By.xpath("//li[text() = 'Terça-Feira']");
    By excecaoQuartaFeira = By.xpath("//li[text() = 'Quarta-Feira']");
    By excecaoQuintaFeira = By.xpath("//li[text() = 'Quinta-Feira']");
    By excecaoSextaFeira = By.xpath("//li[text() = 'Sexta-Feira']");
    By excecaoSabado = By.xpath("//li[text() = 'Sábado']");
    By excecaoDomingo = By.xpath("//li[text() = 'Domingo']");
    By excecaoFeriado = By.xpath("//li[text() = 'Feriado']");
    By btnExcecao = By.xpath("//label[@for = 'zh-checkbox-EXCECAO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxProdutoExcecao = By.xpath("//*[@id='grid-2201729922191976875870']/div[1]/div/div/div[1]");
    By dataExcecao = By.xpath("//div[@data-date = '18/10/2022']");
    By unidadeExcecao = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon='no-border search']");
    By servicoExcecao = By.xpath("//div[@id = 'NMSERVICO']//span[@zh-icon='no-border search']");
    By clicarServico = By.xpath("//div[@class = 'tr cell2']");
    By selecionaServicoFiltro = By.xpath("//div[@class = 'tr cell2 row-editing currentRow']");

    //Exportar Exceção
    By checkBoxProdutoExportacao = By.xpath("//*[@id='grid-6580556123085755595808']/div[1]/div/div/div[1]");
    By btnConfirmar = By.xpath("//li[@data-zh-id='6580556124178481369822']//span[text() = 'Confirmar']");
    By marcaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By dadosExistentesExp = By.xpath("//div[@data-zh-id='6580556121193224773820']//span[@class = 'current']");
    By sobreporExportacao = By.xpath("//li[text() = 'Sobrepor']");
    By servicoSelecionado = By.xpath("//*[@id='grid-9000']/div[2]/div/div[2]");
    By marcaExcecao = By.xpath("//label[@for = 'zh-checkbox-EXCECAO']//div[@class = 'zh-box mousetrap zh-ripple-effect']");





    public void navegaTelaConsumoPorServico(){
        waitForElement(clicaMenu);
        waitForElement(usernameLoginInfoTextArea);
        tempo();
        click(clicaMenu);
        click(clicaPlanejamento);
        click(clicaConsumo);
        click(acessaConsumoPorServico);
        tempo();
    }

    public void adicionaConsumoFixo(String CDFILIAL, String CDSERVFILI){
        Actions actions = new Actions(driver);
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,CDFILIAL);
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDSERVFILI);
        tempo();
        click(selecionaBusca);
        tempo();
        click(diaConsumo);
        tempo();
        click(segundaFeira);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "11/10/2022");
        tempo();
        actions.moveToElement(driver.findElement(btnAdicionar), 0, 10).click().build().perform();

    }

    public void adicionaProduto(String CDPRODUTO, String QTDPRODUTO, String CDPRODUTO_1, String QTDPRODUTO_1){
        click(btnAdicionar);
        tempo();
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        click(pontoDeEntrega);
        tempo();
        click(opcaoCozinhaCentral);
        tempo();
        click(opcaoentregaDireta);
        tempo();
        tempo();
        click(btnSalvar);
        tempo();
        click(btnAdicionar);
        tempo();
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDPRODUTO_1);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO_1);
        tempo();
        click(pontoDeEntrega);
        click(btnSim);
        tempo();
        click(opcaoCozinhaCentral);
        tempo();
        click(opcaoDistribuicao);
        tempo();
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void adicionaNovoProduto(String CDPRODUTO, String QTDPRODUTO){
        click(diaConsumo);
        tempo();
        click(quartaFeira);
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        click(pontoDeEntrega);
        tempo();
        click(opcaoCozinhaCentral);
        tempo();
        click(opcaoentregaDireta);
        tempo();
        tempo();
        click(btnSalvar);
        tempo();

    }

    public String confirmaCadastro(){
        return getText(msgEsperada);
    }

    public String confirmaCadastro_2(){
        return getText(msgEsperada_2);

    }

    public void adicionaExcecao(String CDPRODUTO, String QTDPRODUTO){
        click(btnExcecoes);
        tempo();
        click(dtExcecao);
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void edidaConsumodiaExcecao(){
        click(selecionarProduto);
        tempo();
        click(btnEditar);
        tempo();
        click(qtdProduto);
        clearAndSendKeys(qtdProduto,"20");
        tempo();
        click(btnPontoEntrega);
        tempo();
        click(btnSim);
        tempo();
        click(cozinhaCentral);
        tempo();
        click(opcaoDistribuicao);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnVoltar);

    }

    public void apagaExcecao(){
        click(selecionarProduto);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public String validaExclusao(){
        return getText(msgExclusao);

    }

    public void diaSemConsumo(){
        tempo();
        click(btnDiaSemConsumo);
        tempo();
        click(primeiroDiaSemConsumo);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnSalvar);
        tempo();
        click(segundoDiaSemConsumo);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(opcaoConsumoDia);
        tempo();
        click(diaConsumoPerCapita);
        tempo();
        click(btnSalvar);
        tempo();

    }

    public void edicaoDiaSemConsumo(){
        click(primeiroDiaSemConsumo);
        tempo();
        click(btnEditar);
        tempo();
        click(opcaoConsumoDia);
        tempo();
        click(diaConsumoFixo);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnVoltar);

    }

    public void apagaDiaSemConsumo(){
        tempo();
        click(primeiroDiaSemConsumo);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(segundoDiaSemConsumo);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void alteraApagaConsumoDia(){
       tempo();
       click(abaConsumo);
       tempo();
       click(clicaProduto);
       tempo();
       click(btnEditar);
       click(qtdProduto);
       clearAndSendKeys(qtdProduto,"0");
       tempo();
       click(opcaoCozinhaCentral);
       tempo();
       click(opcaoDistribuicao);
       tempo();
       click(usoDaCentral);
       clearAndSendKeys(usoDaCentral,"5");
       tempo();
       click(btnSalvar);
       tempo();
       click(btnOk);
       click(qtdProduto);
       clearAndSendKeys(qtdProduto,"2");
       click(btnSalvar);
       tempo();
       click(btnOk);
       click(qtdProduto);
       clearAndSendKeys(qtdProduto,"6");
       click(btnSalvar);
       tempo();
       click(excluirProduto);
       tempo();
       click(confirmaMensagem);
       click(diaConsumo);
       tempo();
       click(segundaFeira);
       tempo();
       click(editaProduto_1);
       clearAndSendKeys(novaQtdProduto_1,"5");
       tempo();
       click(editaProduto_2);
       click(editaProduto_2);
       clearAndSendKeys(NovaQtdProduto_2,"10");
       tempo();
       click(carregaGrid);
       click(qtdCentral);
       tempo();
       clearAndSendKeys(informaQtdCentral,"6");
       tempo();
       click(carregaGrid);
       click(salvarAlteracoes);
       tempo();
       click(editarProduto_2);
       tempo();
       click(btnEditar);
       tempo();
       click(opcaoCozinhaCentral);
       tempo();
       click(opcaoentregaDireta);
       click(btnSalvar);
       tempo();
       click(btnVoltar);
       tempo();

    }

    public void excluirProdutos(){
        click(primeiroProduto);
        tempo();
        click(excluirProduto);
        click(confirmaMensagem);
        tempo();
        click(primeiroProduto);
        tempo();
        click(excluirProduto);
        tempo();
        click(confirmaMensagem);

    }

    public void adicionaConsumoPerCapita(){
        Actions actions = new Actions(driver);
        tempo();
        click(tipoConsumo);
        click(consumoPerCapita);
        tempo();
        click(diaConsumo);
        tempo();
        click(tercaFeira);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "11/10/2022");
        tempo();
        click(btnAdicionar);
        tempo();
    }

    public void adicionaProdutoPerCapita(String CDPRODUTO, String QTDPRODUTO, String CDPRODUTO_1, String QTDPRODUTO_1){
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        clearAndSendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnAdicionar);
        tempo();
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        clearAndSendKeys(informaCampoBusca,CDPRODUTO_1);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        clearAndSendKeys(qtdProduto, QTDPRODUTO_1);
        tempo();
        click(opcaoCozinhaCentral);
        tempo();
        click(opcaoDistribuicao);
        tempo();
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void execaoPerCapita(String CDPRODUTO, String QTDPRODUTO, String QTDATUAL){
        click(btnExcecoes);
        tempo();
        click(dtExcecao);
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        clearAndSendKeys(informaCampoBusca,CDPRODUTO);
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        clearAndSendKeys(qtdProduto, QTDPRODUTO);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnOk);
        tempo();
        click(qtdProduto);
        clearAndSendKeys(qtdProduto, QTDATUAL);
        tempo();
        click(btnSalvar);

    }

    public void alterarExcluirProdutoPerCapitaExcecao(String QTDPRODUTO, String QTDATUAL){
        tempo();
        click(selecionarProduto);
        tempo();
        click(btnEditar);
        tempo();
        click(btnPontoEntrega);
        tempo();
        click(btnSim);
        tempo();
        click(cozinhaCentralDistribuicao);
        tempo();
        click(opcaoDistribuicao);
        click(qtdProduto);
        clearAndSendKeys(qtdProduto, QTDPRODUTO);
        click(btnSalvar);
        tempo();
        click(btnOk);
        tempo();
        click(qtdProduto);
        clearAndSendKeys(qtdProduto, QTDATUAL);
        click(btnSalvar);
        tempo();
        click(btnExcluir);
        click(confirmaMensagem);
        tempo();

    }

    public void alteraConsumoPerCapita(){
        tempo();
        click(abaConsumo);
        tempo();
        click(clicaProduto);
        tempo();
        click(btnEditar);
        click(qtdProduto);
        clearAndSendKeys(qtdProduto,"0");
        tempo();
        click(opcaoCozinhaCentral);
        click(opcaoDistribuicao);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnOk);
        click(qtdProduto);
        clearAndSendKeys(qtdProduto,"2");
        click(btnSalvar);
        tempo();
        click(btnVoltar);
        tempo();
        click(editaProduto_2);
        click(editaProduto_2);
        clearAndSendKeys(NovaQtdProduto_2,"0");
        tempo();
        click(carregaGrid);
        tempo();
        click(salvarAlteracoes);
        tempo();
        click(btnOk);
        tempo();
        click(editaProduto_2);
        click(editaProduto_2);
        clearAndSendKeys(NovaQtdProduto_2,"5");
        click(carregaGrid);
        tempo();
        click(salvarAlteracoes);
        tempo();
    }

    public void importarConsumo(String CDFILIAL, String CDSERVFILI){
        Actions actions = new Actions(driver);
        click(tipoConsumo);
        tempo();
        click(opcaoconsumoFixo);
        tempo();
        click(diaConsumo);
        tempo();
        click(segundaFeira);
        tempo();
        click(btnAcoes);
        click(btnImportarConsumo);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,CDFILIAL);
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        /*click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDSERVFILI);
        tempo();*/
        click(selecionaServico);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "13/10/2022");
        tempo();
        click(tipoDeConsumo);
        click(consumoFixo);
        tempo();
        click(diaImportacao);
        tempo();
        click(importaSegundaFeira);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(marcarTodos);
        tempo();
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
    }

    public void sobreporConsumo(){
        Actions actions = new Actions(driver);
        click(clicaProduto);
        tempo();
        click(excluirProduto);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnAcoes);
        click(btnImportarConsumo);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "13/10/2022");
        tempo();
        click(dadosExistentes);
        click(opcaoSobrepor);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(marcarTodos);
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void exportaConsumo(){
        Actions actions = new Actions(driver);
        click(btnAcoes);
        click(btnExportarConsumo);
        tempo();
        click(marcarTodos);
        tempo();
        click(btnExportar);
        tempo();
        click(filtroUnidade);
        click(inputUnidade);
        clearAndSendKeys(inputUnidade,"0003");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        /*click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,CDSERVFILI);
        tempo();*/
        click(selecionaServico);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "18/10/2022");
        tempo();
        click(exportarDestino);
        tempo();
        click(exportaSegunda);
        click(exportaTerca);
        click(exportaQuinta);
        tempo();
        click(okExportaConsumo);
        tempo();
        click(confirmaExportacao);
        tempo();
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0003");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(diaConsumo);
        tempo();
        click(tercaFeira);
        tempo();
        int i = 0;
        while( i < 3) {
            click(clicarProduto);
            click(excluirProduto);
            click(confirmaMensagem);
            i++;
        }
        tempo();
        click(diaConsumo);
        tempo();
        click(quintaFeira);
        tempo();
        int j = 0;
        while( j < 3) {
            click(clicarProduto);
            click(excluirProduto);
            click(confirmaMensagem);
            j++;
        }
        tempo();
        click(limpaFiltro);
        tempo();
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0002");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(selecionaBusca);
        tempo();


    }

    public void substituiProduto(){
        Actions actions = new Actions(driver);
        click(diaConsumo);
        tempo();
        click(segundaFeira);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnSubstituirProduto);
        tempo();
        click(produtoOrigem);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca, "CANFORA");
        tempo();
        click(selecionaProduto);
        tempo();
        click(opcaoTodosUnidade);
        click(campoUnidade);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"0002");
        tempo();
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(opcaoTodosServico);
        click(campoServico);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(campoTipoConsumo);
        click(exportaConsumoFixo);
        tempo();
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "11/10/2022");
        tempo();
        click(diaConsumoTrocaProduto);
        tempo();
        click(trocaProdutoSegunda);
        click(trocaProdutoTerca);
        click(btnOK);
        tempo();
        click(produtoDestino);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"101110100100");
        tempo();
        click(confirmaBusca);
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxSubstituirProduto);
        click(btnSubstituir);
        tempo();
        click(confirmaMensagem);
        tempo();

    }

    public void importaExcecao(){
        Actions actions = new Actions(driver);
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        click(btnAcoes);
        click(importaExcecao);
        tempo();
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0003");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        tempo();
        click(selecionaServico);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "18/10/2022");
        tempo();
        click(btnExcecao);
        tempo();
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxProdutoExcecao);
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"101110100300");
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, "2");
        tempo();
        click(btnSalvar);
        tempo();
        click(btnAcoes);
        click(importaExcecao);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "18/10/2022");
        tempo();
        click(btnExcecao);
        tempo();
        click(dadosExistentes);
        tempo();
        click(opcaoSobrepor);
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxProdutoExcecao);
        click(btnImportar);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        apagaExcecao();

    }

    public void exportarExcecao(){
        Actions actions = new Actions(driver);
        click(dataExcecao);
        click(btnAdicionar);
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"101110201300");
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, "2");
        tempo();
        click(btnSalvar);
        click(btnAcoes);
        tempo();
        click(exportaExcecao);
        tempo();
        click(checkBoxProdutoExportacao);
        click(btnExportar);
        tempo();
        click(unidadeExcecao);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"0003");
        tempo();
        click(confirmaBusca);
        tempo();
        click(servicoExcecao);
        tempo();
        click(lupaFiltro);
        click(clicarServico);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "18/10/2022");
        tempo();
        click(btnConfirmar);
        tempo();
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0003");
        tempo();
        click(clicaUnidade);
        tempo();
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(marcaBusca);
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0002");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(marcaBusca);
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        apagaExcecao();
        tempo();
        click(btnAdicionar);
        click(buscaProduto);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"101110201000");
        tempo();
        click(selecionaProduto);
        click(qtdProduto);
        sendKeys(qtdProduto, "5");
        tempo();
        click(btnSalvar);
        tempo();
        click(btnAcoes);
        tempo();
        click(exportaExcecao);
        tempo();
        click(checkBoxProdutoExportacao);
        click(btnExportar);
        tempo();
        click(unidadeExcecao);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"0003");
        tempo();
        click(marcaBusca);
        tempo();
        click(servicoExcecao);
        tempo();
        click(lupaFiltro);
        tempo();
        click(servicoSelecionado);
        tempo();
        click(limpaDtInicioValidade);
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "18/10/2022");
        tempo();
        click(dadosExistentesExp);
        tempo();
        click(sobreporExportacao);
        click(btnConfirmar);
        tempo();
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0003");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(marcaBusca);
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        click(limpaFiltro);
        click(filtroUnidade);
        click(inputUnidade);
        sendKeys(inputUnidade,"0002");
        tempo();
        click(clicaUnidade);
        click(clicaServico);
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(marcaBusca);
        tempo();
    }

    public void substituiProdutoExcecao(String CDPRODORIG, String CDPRODNOVO){
        Actions actions = new Actions(driver);
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnSubstituirProduto);
        tempo();
        click(produtoOrigem);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca, CDPRODORIG);
        tempo();
        click(selecionaProduto);
        tempo();
        click(opcaoTodosUnidade);
        click(campoUnidade);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"0002");
        tempo();
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(opcaoTodosServico);
        click(campoServico);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca,"00002");
        tempo();
        click(confirmaBusca);
        click(btnOK);
        tempo();
        click(campoTipoConsumo);
        click(exportaConsumoFixo);
        tempo();
        actions.moveToElement(driver.findElement(dtInicioValidade), -150, 0).click().build().perform();
        sendKeys(dtInicioValidade, "18/10/2022");
        tempo();
        click(marcaExcecao);
        tempo();
        click(produtoDestino);
        tempo();
        click(lupaFiltro);
        click(lupaFiltro);
        click(informaCampoBusca);
        sendKeys(informaCampoBusca, CDPRODNOVO);
        tempo();
        click(confirmaBusca);
        click(btnAplicarFiltro);
        tempo();
        click(checkBoxSubstituirProduto);
        click(btnSubstituir);
        tempo();
        click(confirmaMensagem);
        tempo();
        int j = 0;
        while( j < 3) {
            click(clicarProduto);
            click(excluirProduto);
            click(confirmaMensagem);
            j++;
        }
        tempo();
        click(btnExcecoes);
        tempo();
        click(dataExcecao);
        tempo();
        apagaExcecao();


    }


}
